// ***************************************************************************
// *   Copyright (C) 2018 by Paul Lutus                                      *
// *   lutusp@arachnoid.com                                                  *
// *                                                                         *
// *   This program is free software; you can redistribute it and/or modify  *
// *   it under the terms of the GNU General Public License as published by  *
// *   the Free Software Foundation; either version 2 of the License, or     *
// *   (at your option) any later version.                                   *
// *                                                                         *
// *   This program is distributed in the hope that it will be useful,       *
// *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
// *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
// *   GNU General Public License for more details.                          *
// *                                                                         *
// *   You should have received a copy of the GNU General Public License     *
// *   along with this program; if not, write to the                         *
// *   Free Software Foundation, Inc.,                                       *
// *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
// ***************************************************************************

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SaveFileDialog.java
 *
 * Created on Sep 24, 2011, 3:41:25 PM
 */
package Arachnophilia;

import javax.swing.*;

/**
 *
 * @author lutusp
 */
public class SaveFileDialog extends javax.swing.JDialog {
    int outcome = -1;
    /** Creates new form SaveFileDialog */
    public SaveFileDialog(JFrame parent, boolean modal,String title, String message) {
        super(parent, modal);
        initComponents();
        setTitle(title);
        messageTextField.setText(message);
        messageTextField.setOpaque(false);
        this.setLocationRelativeTo(parent);
        setVisible(true);
    }
    
    private void process(int out) {
        outcome = out;
        setVisible(false);
    }
    
    public int outcome() {
        return outcome;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jButton2 = new javax.swing.JButton();
        cancelbutton = new javax.swing.JButton();
        discardbutton = new javax.swing.JButton();
        savebutton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        messageTextField = new javax.swing.JTextArea();

        jButton2.setText("jButton2");

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setMinimumSize(new java.awt.Dimension(400, 200));
        setModal(true);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        cancelbutton.setText("Cancel");
        cancelbutton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                cancelbuttonMouseClicked(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(cancelbutton, gridBagConstraints);

        discardbutton.setText("Discard File");
        discardbutton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                discardbuttonMouseClicked(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(discardbutton, gridBagConstraints);

        savebutton.setText("Save File");
        savebutton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                savebuttonMouseClicked(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(savebutton, gridBagConstraints);

        jScrollPane1.setBorder(null);

        messageTextField.setColumns(20);
        messageTextField.setEditable(false);
        messageTextField.setLineWrap(true);
        messageTextField.setRows(5);
        messageTextField.setWrapStyleWord(true);
        jScrollPane1.setViewportView(messageTextField);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 4;
        gridBagConstraints.ipady = 4;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(8, 8, 8, 8);
        getContentPane().add(jScrollPane1, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cancelbuttonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cancelbuttonMouseClicked
        // TODO add your handling code here:
        process(JOptionPane.CANCEL_OPTION);
    }//GEN-LAST:event_cancelbuttonMouseClicked

    private void discardbuttonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_discardbuttonMouseClicked
        // TODO add your handling code here:
        process(JOptionPane.NO_OPTION);
    }//GEN-LAST:event_discardbuttonMouseClicked

    private void savebuttonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_savebuttonMouseClicked
        // TODO add your handling code here:
        process(JOptionPane.YES_OPTION);
    }//GEN-LAST:event_savebuttonMouseClicked

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            @Override
            public void run() {
                SaveFileDialog dialog = new SaveFileDialog(new javax.swing.JFrame(), true,"This is the title","This is the message");
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelbutton;
    private javax.swing.JButton discardbutton;
    private javax.swing.JButton jButton2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea messageTextField;
    private javax.swing.JButton savebutton;
    // End of variables declaration//GEN-END:variables
}
